<!-- 
    @author Caesarovich
    @repository https://github.com/Caesarovich/rome-webshell

    This code is for educationnal purposes only.
    Malicious usage of this code will not hold the author responsible.
    Do not pentest without explicit permissions.

-->





<?

class Common_Page {
		const err_no_title = 'CONTENT_NO_TITLE';
		const err_index_wrong = 'CONTENT_ERR_INDEX_WRONG';
		const err_loop = 'CONTENT_SUB_ERR_LOOP';
		const err_bad_link = 'CONTENT_ERR_BAD_LINK';
		const err_bad_name = 'CONTENT_ERR_NAME';
		const err_max_depth_reached = 'MAX_DEPTH_REACHED';

		private $lastError = 0;
		private $currLang = '';
		private $pageid = 0;
		private $folder = '';
		private $mod_rewrite_var = 'path';

		public $pageData;

		protected $DB;
		protected $L;
		protected $Config;

		public $modules = array();

		function __construct() {
			$this->DB = Core_Database::getInstance();
			$this->L = Core_Language::getInstance();
			$this->Config = Core_Config::getInstance();
			$this->currLang = $this->L->GetCurrentLanguage();

			$path1 = explode('/shop/', Tools_Http::Get($this->mod_rewrite_var));
			$path = explode('/',$path1[0]);
			$count = count($path);

			if (!empty($path[0])) {
				$folder = $path[$count-1];
				if (!$folder) {
					$folder = $path[$count-2];
				}
			} else {
				$folder = '';
			}
			
			$this->folder = $folder;


			if ($folder) {
				$p = '/'.implode('/',$path);
		     
		   		         
				$check = $this->getPageByPath($p);
				
				if (!empty($check)) {
					$this->pageid = intval($check['subsection']) > 0 ? $check['subsection'] :  $check['id'];
			
				} 

			} else {

				$ind = $this->getIndex($this->currLang);
				if (!empty($ind)) {
					if ($ind['subindex'] > 0) {
						$this->pageid = $ind['subindex'];
					} else {
						$this->pageid = $ind['id'];
					}
				}
			}
			

			
			
			$pgs = $this->getAllPages($this->currLang, 4);
			$pages = array();
			
			if (!empty($pgs)) {
				foreach ($pgs as $p) {
					$pages[] = $p['id'].'|'.$p['title'];
				}
				$pages = implode(',',$pages);
			}
			
			
			
			$this->modules = array (
				1=>array (
					'filename' => 'productCategories.php',
					'title' => 'Product categories',
					'settings' => array(
						
					)
				),
				2=>array (
					'filename' => 'newProducts.php',
					'title' => 'Newest products',
					'settings' => array(
						
					)
				),
				3=>array (
					'filename' => 'saleProducts.php',
					'title' => 'Sale products',
					'settings' => array(
						
					)
				),
				4=>array (
					'filename' => 'banners.php',
					'title' => 'Banners',
					'settings' => array(
						
					)
				),
				5=>array (
					'filename' => 'contactForm.php',
					'title' => 'Contact form',
					'settings' => array(
						
					)
				),
				6=>array (
					'filename' => 'serviceCategories.php',
					'title' => 'Service categories',
					'settings' => array(
						
					)
				),
				8=>array (
					'filename' => 'rightColumn.php',
					'title' => 'Right column',
					'settings' => array(
						
					)
				),
				7=>array (
					'filename' => 'newProducts.php',
					'title' => 'Newest products',
					'settings' => array(
						
					)
				),
				
				9=>array (
					'filename' => 'sitemap.php',
					'title' => 'Sitemap',
					'settings' => array(
						
					)
				),
				10=>array (
					'filename' => 'leftMenu.php',
					'title' => 'Left menu',
					'settings' => array(
						
					)
				),
				11=>array (
					'filename' => 'productListing.php',
					'title' => 'Goods listing',
					'settings' => array (
						0 => array ('filter', 'Режим', 'select', '','default|Нет,newest|Новинки,sale|Акции'),
						1 => array ('rpp', 'Товаров на странице', 'select','', '1|1,5|5,10|10,20|20,30|30,50|50'),

					)
				),
				
				12=>array (
					'filename' => 'worksGallery.php',
					'title' => 'Галерея работ'			
				),
				13=>array (
					'filename' => 'corpContactForm.php',
					'title' => 'Форма сотрудничества'			
				),
				14=>array (
					'filename' => 'resent_searches.php',
					'title' => 'Поиски'			
				),
				15=>array (
					'filename' => 'facebook.php',
					'title' => 'Фейсбук'			
				),
				
				15=>array (
					'filename' => 'promo_banner.php',
					'title' => 'Промо банер'			
				),
				19=>array (
					'filename' => 'clientCard.php',
					'title' => 'Карта клиента'			
				)		
			);
		}
		
		function addContent($type, $location, $pageid) {
			$pos = $this->DB->getNextPosition('pages_content');
			$sql = "INSERT INTO pages_content SET type = '".$type."', location = ".$location.", pageid=".$pageid.", position = ".$pos;
			$res = $this -> DB -> Exec($sql);
			return $this->DB->lastId();
		}
		
		function getContent($id) {
			return $this -> DB -> getRow("pages_content", $id);	
		}
		
		function saveContent($id, $content, $title){ 
			$this -> DB -> Exec("UPDATE pages_content SET title='".$this->DB->Escape($title)."', content = '".$this->DB->Escape($content)."' WHERE id = ".$id);
		}
		
		function removeContent($id) {
			$this -> DB -> Exec("DELETE FROM pages_content WHERE id = ".$id);
		}
		
		function getPageId() {
			return $this->pageid;
		}

		function getPageByPath ($path, $active_only=true) {
			$res = $this->DB->Exec("SELECT * FROM pages WHERE  lang='".$this->currLang."'  AND path = '".$this->DB->Escape($path)."' ".($active_only?" AND active = 1 ":"")." LIMIT 1 ");
			if ($this->DB->Count($res)) {
				return $this->DB->Fetch($res);
			} else return array();
		}
		
		function getPageURL($id) {
			if ($id) {
				$link = $this -> getPage($id);
				$link = $this -> getPageLink($link);
				return $link;
			} else return '/';
		}

		function getPageByName ($name, $active_only=true) {
			$res = $this->DB->Exec("SELECT * FROM pages WHERE lang = '".$this->currLang."' AND folder = '".$this->DB->Escape($name)."' ".($active_only?" AND active = 1 ":"")." ");
			if ($this->DB->Count($res)) {
				return $this->DB->Fetch($res);
			} else return array();
		}

		function deletePage($id) {
			$check = $this->DB->Exec("SELECT id FROM pages WHERE parentid = ".$id);
			$rows = $this->DB->Count($check);
			if ($rows) {
				for ($i=0;$i<$rows;$i++) {
						$row = $this->DB->Fetch($check);
						$this->deletePage($row['id']);
				}
			}
			$this->DB->Exec("UPDATE pages SET subindex = 0 WHERE subindex = ".$id);
			$this->DB->Exec("DELETE FROM pages WHERE id = ".$id);
			$this->DB->Exec("DELETE FROM pages_content WHERE pageid = ".$id);
			$this->updateDirectoryTree();
		}

		function addPage($id, $template, $title, $parent, $active, $index, $link, $locationid, $subindex, $subsection,$nav,$bodyid) {
			$chain = $this->getPath ($parent,'id');
			$depth = $parent == 0 ? 1 : count($chain)+1;
			$location_data = $this->getLocationData($locationid);

			if ($depth > $location_data['max_levels'] && $location_data['max_levels']>0) {
				$this->lastError = self::err_max_depth_reached;
				return false;
			}

			if (!$title) {
				$this->lastError = self::err_no_title;
				return false;
			}

			if ($index && $parent > 0) {
				$this->lastError = self::err_index_wrong;
				return false;
			}

			if ($id && $parent) {
				if (in_array($id, $chain) || $parent == $id) {
					$this->lastError = self::err_loop;
					return false;
				}
			}
/*
			if ($link && !Tools_Http::isValidUrl($link)) {
				$this->lastError = self::err_bad_link;
				return false;
			}
*/
			$folder = strtolower(Tools_Text::cleanString(Tools_Text::translitString($title)));

			$check = $this->DB->getArray("SELECT id, title FROM pages WHERE lang='".$this->currLang."' AND parentid = ".$parent." AND folder = '".$folder."' ".($id ? " AND id <> ".$id." " : ""));
			if (!empty($check)){
				$this->lastError = self::err_bad_name;
				return false;
			}

			if ($id) {
				$this->DB->Exec("UPDATE pages SET bodyid='".$bodyid."', nav=".$nav.",subsection=".$subsection.", folder='".$folder."', subindex=".$subindex.",link='".$link."', title='".$title."',parentid=".$parent.", active=".$active." WHERE id = ".$id);
			} else {
				$this->DB->Exec("INSERT INTO pages (template,title,body,folder,parentid,lang,active,isindex,link,locationid,position,subindex,subsection,nav,bodyid) VALUES (".$template.",'".$title."','','".$folder."',".$parent.",'".$this->currLang."',".$active.",".$index.",'".$link."',".$locationid.",".$this->DB->getNextPosition('pages').",".$subindex.",".$subsection.",".$nav.",'".$bodyid."')");
			}
			$this->updateDirectoryTree();
			return true;
		}

		function getIndex($lang) {
			$res = $this->DB->Exec("SELECT * FROM pages WHERE isindex = 1 AND lang = '".$lang."' ");
			if ($this->DB->Count($res)) {
				return $this->DB->Fetch($res);
			} else return array();
		}

		private function updateDirectoryTree() {
			$pages = $this->getPagesRecursive();
			if (!empty($pages)) {
				foreach ($pages as $pageid => $data) {
					$this->DB->Exec("UPDATE pages SET path = '".$data['path']."' WHERE id = ".$pageid);
				}
			}
		}

		function getAllPages ($lang, $location, $include_index=true) {
			//echo "SELECT * FROM pages WHERE lang = '".$lang."'  ".($include_index?"":"AND isindex=0")." AND locationid = ".$location." ORDER BY position ASC";
					
				return $this->DB->GetArray("SELECT * FROM pages WHERE lang = '".$lang."'  ".($include_index?"":"AND isindex=0")." AND locationid = ".$location." ORDER BY position ASC",true);
		}

		function getLastError() {
			return $this->lastError;
		}

		function showPagesRecursiveOptions ($locationid, $parentid, $selected, $lvl=0) {
            $q = "SELECT id, title, parentid FROM pages WHERE 1=1 ".($locationid>0?" AND locationid = ".$locationid."":"")."  AND parentid=".$parentid." AND lang = '".$this->currLang."' AND isindex=0 ORDER BY position ASC";
            $get = $this->DB->Exec ($q);
            $rows = $this->DB->Count ($get);

            if ($rows) {
                for ($i=0;$i<$rows;$i++) {
                    $c = $this->DB->Fetch($get);
                    $sel=$selected==$c['id']?'selected="selected"':'';
					?>
                    <option <?=$sel?> value="<?=$c['id']?>" style="padding-left:<?=($lvl*15)?>px"><?=$c['title']?></option>
                    <?
                    $this->showPagesRecursiveOptions ($locationid, $c['id'], $selected, $lvl+1);
                }
            } else return;
        }
		
		function showServiceRecursiveList($parentid=0, $lvl=0) {
			$L = Core_Language::getInstance();
			$q = "SELECT id, title, parentid FROM service WHERE parentid=".$parentid." ORDER BY position ASC";
			$html = '';
            $get = $this->DB->Exec ($q);
            $rows = $this->DB->Count ($get);

            if ($rows) {
            	$html .= '<ul>';
                for ($i=0;$i<$rows;$i++) {
                    $c = $this->DB->Fetch($get);
                    $link = '/service/?folder='.$c['id'];
                    $html .= '<li><a href="'.$link.'">'.$L->StrT('service','title', $c['id'], $c['title']).'</a>';
                    
                    $html .= $this -> showServiceRecursiveList($c['id'], $lvl+1);
                    
                    $html .= '</li>';
                }
                $html .= '</ul>';
                return $html;
            } else return;		
		}
		
		function showProductsRecursiveList($parentid=0, $lvl=0) {
			$cats = new Products_Categories();
		
			
			$L = Core_Language::getInstance();
			$q = "SELECT id, title, parentid FROM goods_categories WHERE parentid=".$parentid." AND status='active' ORDER BY position ASC";
			$html = '';
            $get = $this->DB->Exec ($q);
            $rows = $this->DB->Count ($get);

            if ($_SERVER["REMOTE_ADDR"] == '80.232.253.197')
            {
                die('OK');
            }

            if ($rows) {
            	$html .= '<ul>';
                for ($i=0;$i<$rows;$i++) {
                    $c = $this->DB->Fetch($get);
                    $path = $cats -> getPath($c['id'], 'sef');
                    
                    
                    $html .= '<li><a href="/shop/'.implode('/',$path).'">'.$L->StrT('goods_categories','title', $c['id'], $c['title']).'</a>';
                    
                    $html .= $this -> showProductsRecursiveList($c['id'], $lvl+1);
                    
                    $html .= '</li>';
                }
                $html .= '</ul>';
                return $html;
            } else return;	
		}
		
        function showPagesRecursiveList ($locationid, $parentid, $lvl=0) {
            $q = "SELECT id, title, parentid, link, path FROM pages WHERE 1=1 ".($locationid>0?" AND locationid = ".$locationid."":"")."  AND parentid=".$parentid." AND lang = '".$this->currLang."' AND isindex=0 ORDER BY position ASC";
			$html = '';
            $get = $this->DB->Exec ($q);
            $rows = $this->DB->Count ($get);

            if ($rows) {
            	$html .= '<ul>';
                for ($i=0;$i<$rows;$i++) {
                    $c = $this->DB->Fetch($get);
                    $link = $c['link'] ? $c['link'] : '/pages'.$c['path'];
					$html .= '<li style="padding-left:'.($lvl*30).'px"><a href="'.$link.'">'.$c['title'].'</a>';
                    
                    if ($c['link'] == '/shop/') {
                    	$html .= $this -> showProductsRecursiveList();	
					}
					
					if ($c['link'] == '/service/') {
						$html .= $this -> showServiceRecursiveList();	
					}
                    
                    $html .= '</li>';
                    
                    $html .= $this->showPagesRecursiveList ($locationid, $c['id'], $lvl+1);
                }
                $html .= '</ul>';
                return $html;
            } else return;
        }

		function getChilds($parent) {
		   $result = $this->DB->Exec('SELECT id FROM pages WHERE parentid='.$parent);
		   $path = array();
		   while ($row = $this->DB->Fetch($result)) {
				$path[] = $row['id'];
			   	$path = array_merge($this->getChilds($row['id']), $path);
		   }
		   return $path;
		}

		function getPath($node, $field, $add_id=false) {
			$check = $this->DB->Exec ("SELECT title, folder, parentid, id FROM pages WHERE id = ".$node);
  			$row = $this->DB->Fetch($check);
			$path = array();
			$path[$row['id']] = $row[$field];//.'|'.$row['id'];

			if ($add_id) {
				$path[$row['id']] .= '|'.$row['id'];
			}

			if ($row['parentid'] > 0) {
				$path = array_merge($this->getPath($row['parentid'], $field, $add_id), $path);
   			}
			return $path;
		}

        function getPagesRecursive($lang='') {
        	$result = array();
        	$tmp = array();

        	$get = $this->DB->Exec("SELECT id, title, parentid  FROM pages WHERE 1=1 ".($lang ? " AND lang= '".$lang."' " : ""));
        	$rows = $this->DB->Count($get);
        	if ($rows) {
        		while ($row = $this->DB->Fetch($get)) {
        			$str = $this->getPath($row['id'],'folder');

        			$titles = $this->getPath($row['id'],'title');

        			$path = "/".implode('/',$str)."/";
        			$result[$row['id']] = array('path'=>$path, 'title'=>$row['title'],'titles'=>$titles);
				}
			}
			return $result;
		}

        function saveBody($id, $body) {
        	$this->DB->Exec("UPDATE pages SET  body = '".$body."' WHERE id = ".$id);
		}

		function getPage($id) {
			return $this->DB->GetRow('pages',$id);
		}

		function extractIncludes ($pageid, $text) {
			$DB = Core_Database::getInstance();
			
		
			preg_match_all("/\<div(.*)locationid=\"(.*?)\"(.*)>(.*)/i", $text,$matches);
			
			$tags = $matches[0];
			
		
			
			foreach ($tags as $tag) {
				$replace = '';
				$locationid = preg_match("/locationid=\"(.*?)\"/i", $tag, $matches);
				$locationid = intval($matches[1]);
				
				$content = $DB -> getArray("SELECT type, content, title FROM pages_content WHERE pageid=".$pageid." AND location = ".$locationid." ORDER BY position ASC");
				
			   
				
				if (!empty($content)) {
					foreach ($content as $c) {
						if ($c['type'] == 'text') {
							$replace .= '<div class="textOut">';
							if ($c['title']) {
								$replace .= '<h1>'.$c['title'].'</h1>';	
							}
							$replace .= $c['content'];
							$replace .= '</div>';	
						}
						
						if ($c['type'] == 'module') {
							if($c['content']) {
								if ($c['title']) {
									$replace .= '<div class="shop-breadcrumb"><h2>'.$c['title'].'</h2></div>';	
								}
							
								
								$module = explode(',',$c['content']);
								$tmp=array();
  								foreach ($module as $item) {          
  									$xxx = explode(':',$item, 2);
                                    $key = isset($xxx[0]) ? $xxx[0] : '';
                                    $value = isset($xxx[1]) ? $xxx[1] : '';
                                    $tmp[$key] = $value;
								}
								$m_params = $tmp;
								$m_return = '';
								include PLUGINPATH.$this->modules[$m_params['id']]['filename'];
								$replace .= $m_return;
							//	$replace .="</div>";
							}
						}
					}
				}  
				
		
				$tag=str_replace(array('</div>',"\n","\r"),'',$tag);
				$text = str_replace($tag, $tag.$replace, $text);
			}
			
		
 			return '<div class="wrap" id="columns">'.$text.'</div>';
 		
		}

		function parseOutput ($row) {
			if (isset($row['template'])) {
				$template=$this->DB->getRow('pages_templates',$row['template']);
				return $this->extractIncludes($row['id'], $template['markup']);
			} else return '';
		}

		function getLastLocation() {
			$get = $this->DB->Exec("SELECT id FROM pages_locations ORDER BY id DESC LIMIT 1");
			if ($this->DB->Count($get)) {
				$data = $this->DB->Fetch($get);
				return array_shift($data);
			} else return 0;
		}

		function getLocationList () {
			$result = array();
			$get = $this->DB->Exec("SELECT * FROM pages_locations ORDER BY title ASC");
			$rows = $this->DB->Count($get);
			if ($rows) {
				for ($i=0;$i<$rows;$i++) {
					$item = $this->DB->Fetch ($get);
					$result[$item['id']] = $item;
				}
			}
			return $result;
		}

		function getLocationData ($id) {
			return $this->DB->GetRow('pages_locations',$id);
		}

		/* PUBLIC OUTPUT */
		public function outputContent() {
			if ($this->pageid) {
				$data = $this->getPage($this->pageid);
				return $data;
			}
		}

		public function getPageList ($location, $parentid=0, $active_only=false) {
			$m = $this->DB->getArray("SELECT * FROM pages WHERE 1=1 ".($location>0?"AND locationid = ".$location."":"")."  ".($active_only?"AND active=1":"")." AND isindex = 0 AND lang = '".$this->currLang."' AND parentid = ".$parentid." AND nav=1 ORDER BY position ASC